; Final Fantasy - Kung Fu - Bug Fix - Version 0.8 (alpha)

; Copyright 1984 Square Enix
; Modified  2007 Levi Aho
; All Rights Reversed

; =============================================================================

; 0x2D966 - 0x2D998 : 51 bytes : Original [Kung Fu Hustle] Code
; 0x2FBE0 - 0x2FBFF : 32 bytes : Original Unused Space

; 0x2D966 - 0x2D9__ : xx bytes : New [Kung Fu Strike] Code
; 0x2D9__ - 0x2D998 : xx bytes : New Unused Space
; 0x2FBE0 - 0x2FB__ : xx bytes : New [Kung Fu Block] Code
; 0x2FB__ - 0x2FBFF : xx bytes : New Unused Space

; --- Function [Kung Fu Strike] -----------------------------------------------

.org $9966

kung_fu_strike:

	; 13 bytes - Class Check

	LDY #$00		; 2
	LDA ($86),Y		; 2
	CMP #$02		; 2
	BEQ +			; 2
	CMP #$08		; 2
	BEQ +			; 2
	RTS				; 1
	
	; 12 bytes - Weapons Check
	
*	LDY #$18		; 2
*	LDA ($86),Y		; 2
	BMI +			; 2
	INY				; 1
	TYA				; 1
	CMP #$1C		; 2
	BNE -			; 2
	
	; 11 bytes - Kung Fu Strike
	
	LDY #$26		; 2
	LDA ($86),Y		; 2
	CLC				; 1
	ADC #$01		; 2
	ASL				; 1
	LDY #$20		; 2
	STA ($86),Y		; 1
	
	; 3 bytes - Jump to [Kung Fu Block]

*	JMP kung_fu_block	; 3

; --- Function [Kung Fu Strike] End -------------------------------------------

.advance $9999

; --- Function [Kung Fu Block] ------------------------------------------------

.org $BBE0

kung_fu_block:
	
	; 12 bytes - Armor Check
	
	LDY #$1C		; 2
*	LDA ($86),Y		; 2
	BMI +			; 2
	INY				; 1
	TYA				; 1
	CMP #$20		; 2
	BNE -			; 2

	; 11 bytes - Kung Fu Block
	
	LDY #$26		; 2
	LDA ($86),Y		; 2
	CLC				; 1
	ADC #$01		; 2
	LDY #$22		; 2
	STA ($86),Y		; 2
	
	; 1 byte - Return

*	RTS				; 1

; --- Function [Kung Fu Block] End --------------------------------------------

.advance $BC00

; =============================================================================

